﻿namespace FunWithXMLs.ViewModel
{
  using System.Collections.Generic;
  using System.IO;
  using System.Windows;
  using System.Xml.Linq;
  using System.Xml.Serialization;

  using FunWithXMLs.Model;

  public class FunWithXMLsViewModel
  {
    public RelayCommand Serialization
    {
      get
      {
        return new RelayCommand(param => this.Serialize());
      }
    }

    public RelayCommand Linq2XML
    {
      get
      {
        return new RelayCommand(param => this.Linq2XMLExecute());
      }
    }

    private void Linq2XMLExecute()
    {
      XElement myLinq2XML = new XElement(
        "project",
        new XElement(
          "menu",
          new XAttribute("back_image", string.Empty),
          new XElement(
            "mnu_item",
            new XAttribute("txt", "Linq2XML item 1"),
            new XAttribute("anotherAttribute", "another attribute 1"),
            new XElement("sub_item", new XAttribute("txt", "Sub item 1"), new XAttribute("articleId", "1"))),
          new XElement(
            "mnu_item",
            new XAttribute("txt", "Linq2XML item 2"),
            new XAttribute("anotherAttribute", "another attribute 2"),
            new XElement("sub_item", new XAttribute("txt", "Sub item 2"), new XAttribute("articleId", "2")))));

      string savePath = Path.ChangeExtension(System.Reflection.Assembly.GetEntryAssembly().Location, ".xml");

      myLinq2XML.Save(Path.ChangeExtension(System.Reflection.Assembly.GetEntryAssembly().Location, ".xml"));

      MessageBox.Show("File saved to: " + savePath);
    }

    private void Serialize()
    {
      Project serializedProject = new Project();

      serializedProject.Menu = new Menu();
      serializedProject.Menu.backImage = string.Empty;

      MenuItem menuItem = new MenuItem();

      menuItem.Txt = "Serialization item 1";
      menuItem.AnotherAttribute = "another attribute 1";

      menuItem.SubItem = new SubItem();
      menuItem.SubItem.Txt = "Sub item 1";
      menuItem.SubItem.ArticleId = "1";

      serializedProject.Menu.MenuItem = new List<MenuItem>();

      serializedProject.Menu.MenuItem.Add(menuItem);

      menuItem = new MenuItem();

      menuItem.Txt = "Serialization item 2";
      menuItem.AnotherAttribute = "another attribute 2";

      menuItem.SubItem = new SubItem();
      
      menuItem.SubItem.Txt = "Sub item 2";
      menuItem.SubItem.ArticleId = "2";

      serializedProject.Menu.MenuItem.Add(menuItem);

      string savePath = Path.ChangeExtension(System.Reflection.Assembly.GetEntryAssembly().Location, ".xml");

      TextWriter txtWriter = new StreamWriter(savePath);

      XmlSerializerNamespaces ns = new XmlSerializerNamespaces();
      ns.Add("", "");

      XmlSerializer xmlSerializer = new XmlSerializer(typeof(Project), "");
      xmlSerializer.Serialize(txtWriter, serializedProject, ns);
      txtWriter.Close();

      MessageBox.Show("File saved to: " + savePath);
    }
  }
}